=== modified file 'rules/annotations/ocx_conversion.rules'
--- rules/annotations/ocx_conversion.rules	2020-01-29 14:38:53 +0000
+++ rules/annotations/ocx_conversion.rules	2020-02-25 17:11:49 +0000
@@ -4,7 +4,7 @@
 ** Module   : ocx_conversion.rules
 ** Abstract : Converts supported OCX objects to 4GL widgets.
 **
-** Copyright (c) 2018-2019, Golden Code Development Corporation.
+** Copyright (c) 2018-2020, Golden Code Development Corporation.
 **
 ** _#_ _I_ __Date__ _________________________________Description__________________________________
 ** 001 HC  20181127 Initial version.
@@ -28,6 +28,7 @@
 **                  Added rules to ignore (eliminate) RELEASE OBJECT statement for known com-handle
 **                  Make noop-com annotation to work with the new rules.
 **                  Fixed indexed properties conversion rules.
+** 008 SBI 20200225 Added Calendar widget support.
 */
  -->
 <!--
@@ -117,9 +118,11 @@
    <variable name="map3"           type="java.util.Map" />
    <variable name="map4"           type="java.util.Map" />
    <variable name="map5"           type="java.util.Map" />
+   <variable name="map6"           type="java.util.Map" />
 
    <variable name="ref"            type="com.goldencode.ast.AnnotatedAst" />
    <variable name="ref1"           type="com.goldencode.ast.Aast" />
+   <variable name="ref3"           type="com.goldencode.ast.Aast" />
    <variable name="refl"           type="java.util.List" />
    <variable name="it"             type="java.util.Iterator" />
    <variable name="parRef"         type="com.goldencode.ast.Aast" />
@@ -135,6 +138,7 @@
    <variable name="name"           type="java.lang.String" />
    <variable name="name1"          type="java.lang.String" />
    <variable name="name2"          type="java.lang.String" />
+   <variable name="name3"          type="java.lang.String" />
 
    <variable name="callbacks"      type="java.util.List" />
    <variable name="widgetClass"    type="java.lang.Class"/>
@@ -226,6 +230,7 @@
          <action>widgetKwords.put("HTML-BROWSER", prog.kw_html_bws)</action>
          <action>widgetKwords.put("IMAGELIST", prog.kw_il_img)</action>
          <action>widgetKwords.put("PROGRESS-BAR", prog.kw_prog_bar)</action>
+         <action>widgetKwords.put("CALENDAR", prog.kw_calendar)</action>
 
          <action>widgetClasses = create("java.util.HashMap")</action>
          <action>widgetClasses.put("TREELIST", classForName("com.goldencode.p2j.ui.TreeList"))</action>
@@ -234,6 +239,7 @@
          <action>widgetClasses.put("HTML-BROWSER", classForName("com.goldencode.p2j.ui.HtmlBrowser"))</action>
          <action>widgetClasses.put("IMAGELIST", classForName("com.goldencode.p2j.ui.ImageList"))</action>
          <action>widgetClasses.put("PROGRESS-BAR", classForName("com.goldencode.p2j.ui.ProgressBar"))</action>
+         <action>widgetClasses.put("CALENDAR", classForName("com.goldencode.p2j.ui.Calendar"))</action>
 
          <!-- fill the method aliases, where the key is the original com method/property name (in lower case),
               the rules will prepend is/get/set accordingly to the aliased values so for properties,
@@ -282,10 +288,18 @@
          
          <!-- PROGRESS-BAR -->
          <action>map5 = create("java.util.HashMap")</action>
-         <action>map5.put("mousepointer"          , "ProgBarMousePointer")</action>
-         <action>map5.put("refresh"               , "progBarRefresh")</action>
+         <action>map5.put("mousepointer"          , "MousePointerExt")</action>
+         <action>map5.put("refresh"               , "refreshUI")</action>
          <action>aliasMap.put("PROGRESS-BAR"      , map5)</action>
-    
+         
+         <!-- Calendar -->
+         <action>map6 = create("java.util.HashMap")</action>
+         <action>map6.put("value"            , "DateTimeValue")</action>
+         <action>map6.put("CustomFormat"     , "CustomFormat")</action>
+         <action>map6.put("font:name"        , "FontName")</action>
+         <action>map6.put("font:size"        , "FontSize")</action>
+         <action>map6.put("format"           , "FormatStyle")</action>
+         <action>aliasMap.put("CALENDAR"   , map6)</action>
       </rule>
    </init-rules>
 
@@ -406,7 +420,7 @@
                </rule>
 
                <rule>ocxHandle == null and isConversion
-                  <action>ocxHandleKey = copy.text)</action>
+                  <action>ocxHandleKey = copy.text</action>
                   <action>ocxHandleKey = ocxHandleKey.toUpperCase()</action>
                   <action>ocxHandle = ch2th.get(ocxHandleKey)</action> 
                   <action>cache = null</action>
@@ -428,10 +442,9 @@
                <rule>ocxHandle != null
                   <rule>ocxHandle != null and copy.parent.type == prog.com_invocation
                      <action>printfln("INFO: FWD OCX Extension: convert %s to %s.", ocxHandleKey, ocxHandle)</action>
-       
                      <!-- get legacy node -->
                      <rule>not isConversion
-                     	<action>ref2 = copy.parent.nextSibling</action>
+                        <action>ref2 = copy.parent.nextSibling</action>
                      </rule>
 
                      <!-- no legacy node, only handle -->
@@ -447,151 +460,10 @@
                      </rule>
 
                      <!-- convert legacy node -->
+                     <action>ref2 = execLib("processLegacyNode",copy, ref2, ocxHandle, ocxHandleKey, cache, isConversion)</action>
                      <rule>ref2 != null
-                        <action>name = ref2.text</action>
-
-                        <!-- get the method/prop alias -->
-                        <action>ocxType = ch2wtype.get(ocxHandleKey)</action>
-
-                        <action>map = aliasMap.get(ocxType)</action>
-                        <rule>map != null
-                           <action>name1 = name.toLowerCase()</action>
-                           <action>name2 = map.get(name1)</action>
-                           <rule>name2 != null
-	                          <action>name = name2</action>
-                           </rule>
-                           <rule>name2 == null
-                             <!-- check for composed properties like font:name -->
-                             <action>ref1 = copy.parent.parent.nextSibling</action>
-                             <rule>ref1 != null and ref1.type == prog.com_property
-                                <action>name2 = ref1.text.toLowerCase()</action>
-                             	<action>name1 = sprintf("%s:%s", name1, name2)</action>
-	                            <action>name2 = map.get(name1)</action>
-	                            <rule>name2 != null
-	                               <action>ref1 = copy.parent.parent</action>
-	                               <action>ref = copy.parent.parent.parent</action>
-	                               <action>ref1.move(ref.parent, 0)</action>
-	                               <action>ref.remove()</action>
-	                               <action>name = name2</action>
-	                            </rule>
-                             </rule>
-                           </rule>
-                        </rule>
-
-                        <action>widgetClass = widgetClasses.get(ocxType)</action>
-
-                        <!-- find the root com_invocation -->
-                        <action>ref = copy.parent</action>
-                        <action>rootComInvocCpy = ref</action>
-                        <while>ref.type == prog.com_invocation
-                           <action>rootComInvocCpy = ref</action>
-                           <action>ref = ref.parent</action>
-                        </while>
-
-                        <!-- find the java counterpart method -->
-                        <action>name1 = getLegacyName(widgetClass, name)</action>
-
-                        <rule>name1 == null and
-                              rootComInvocCpy.parent.type == prog.assign and
-                              rootComInvocCpy.indexPos == 0
-                           <!-- for prop assignment -->
-                           <action>name1 = sprintf("set%s", name)</action>
-                           <action>name1 = getLegacyName(widgetClass, name1)</action>
-                        </rule>
-
-                        <!-- for prop getter or method invocation -->
-                        <rule>name1 == null
-                           <action>name1 = sprintf("get%s", name)</action>
-                           <action>name1 = getLegacyName(widgetClass, name1)</action>
-                        </rule>
-
-                        <!-- for prop getter or method invocation -->
-                        <rule>name1 == null
-                           <action>name1 = sprintf("is%s", name)</action>
-                           <action>name1 = getLegacyName(widgetClass, name1)</action>
-                        </rule>         
-
-                        <rule>name1 == null
-                           <action>printfln("WARN: FWD OCX Extension: Failed to resolve legacy name for %s. Is %s defined in %s?", name, name, widgetClass)</action>
-                           <action>copy.putAnnotation("noop-com", true)</action>
-                        </rule>
-
-                        <rule>name1 != null
-                           <action>reftype1 = -1</action>
-                           <action>reftype = prog.lookupKeywordToken(name1)</action>
-                           <rule>reftype == -1
-                              <action>printfln("WARN: FWD OCX Extension: Failed to resolve keyword for %s.", name1)</action>
-                              <action>copy.putAnnotation("noop-com", true)</action>
-                              <action on="false">reftype1 = lookupAttributeOrMethod(reftype)</action>
-                              <rule on="false">reftype1 == -1
-                                 <action>printfln("WARN: FWD OCX Extension: Failed to resolve attribute or method type for %s.", name1)</action>
-	                         <action>copy.putAnnotation("noop-com", true)</action>
-                              </rule>
-                           </rule>
-
-                           <rule>reftype1 != -1
-                              <!-- is this an indexed COM property being assigned? -->
-                              <action>methPropCpy = rootComInvocCpy.getImmediateChild(createSet(prog.com_method, prog.com_property), null)</action>
-                              <rule>rootComInvocCpy.parent.type == prog.assign and
-                                    rootComInvocCpy.indexPos == 0 and
-                                    methPropCpy.getImmediateChild(prog.com_parameter, null) != null
-
-                                 <!-- get the assigning expression and make it a parameter -->
-                                 <action>ref1 = rootComInvocCpy.nextSibling</action>
-
-                                 <!-- the com parameter will be converted below -->
-                                 <action>ref1.type = prog.com_parameter</action>
-                                 <action>ref1.text = ""</action>
-                                 <action>ref1.move(methPropCpy, -1)</action>
-                              </rule>
-
-                              <!-- set legacy node properties -->
-                              <action>ref2.type = reftype1</action>
-                              <action>ref2.text = name1</action>
-                              <action>ref2.putAnnotation("oldtype", #(long)reftype)</action>
-
-                              <!-- lookup for com parameters and replace with parameters -->
-                              <action>ref1 = ref2.firstChild</action>
-                              <while>ref1 != null
-                                 <action>ref2 = null</action>
-                                 <rule>ref1.type == prog.com_parameter
-                                    <action>ref1.type = prog.parameter</action>
-                                    <action>ref2 = ref1</action>
-                                 </rule>
-                                 <action>ref1 = ref1.nextSibling</action>
-
-                                 <!-- check for empty parameter and remove it -->
-                                 <rule>ref2 != null and ref2.numChildren == 0
-                                    <action>ref2.remove()</action>
-                                 </rule>
-                              </while>
-
-                              <!-- convert var_com_handle into var_handle -->
-                              <action>copy.type = prog.var_handle</action>
-                              <action>copy.text = ocxHandle</action>
-
-                              <!-- remove second token since is no longer needed -->
-                              <rule>cache != null
-                                 <action>cache.remove()</action>
-                              </rule>
-
-                              <!-- rearrange nodes and remove unnecessary node -->
-                              <rule>isConversion == false and copy.parent.parent != null and copy.parent.parent.type == prog.com_invocation
-                                 <action>ref1 = copy.parent</action>
-                                 <action>invoc = copy.parent.parent</action>
-                                 <action>invoc.type = prog.colon</action>
-                                 <action>copy.move(invoc, 0)</action>
-                                 <action>ref1.remove()</action>
-                              </rule>
-
-                              <!-- when is conversion  -->
-                              <rule>isConversion == true and copy.parent != null and copy.parent.type == prog.com_invocation
-                                 <action>invoc = copy.parent</action>
-                                 <action>invoc.type = prog.colon</action>
-                              </rule>
-                           </rule>
-                        </rule>
-                     </rule>
+                        <action>execLib("processLegacyNode",copy, ref2, ocxHandle, ocxHandleKey, cache, isConversion)</action>
+                     </rule>   
                   </rule>
                </rule>
             </rule>
@@ -898,7 +770,178 @@
    </post-rules>
 
    <func-library access="private">
-
+      <function name="processLegacyNode">
+         <parameter name="copy" type="com.goldencode.ast.Aast" />
+         <parameter name="ref2" type="com.goldencode.ast.Aast" />
+         <parameter name="ocxHandle"       type="java.lang.String"/>
+         <parameter name="ocxHandleKey"    type="java.lang.String"/>
+         <parameter name="cache"           type="com.goldencode.ast.Aast"/>
+         <parameter name="isConversion"    type="java.lang.Boolean"/>
+
+         <return    name="ref3"            type="com.goldencode.ast.Aast"/>
+
+         <variable name="ref1"     type="com.goldencode.ast.Aast" />
+         <variable name="name"     type="java.lang.String"/>
+         <variable name="name1"    type="java.lang.String"/>
+         <variable name="name2"    type="java.lang.String"/>
+         <variable name="name3"    type="java.lang.String"/>
+         <variable name="ocxType"  type="java.lang.String" />
+         <variable name="reftype"  type="java.lang.Integer"/>
+         <variable name="reftype1" type="java.lang.Integer"/>
+         <variable name="invoc"    type="com.goldencode.ast.Aast"/>
+         <variable name="ref"      type="com.goldencode.ast.AnnotatedAst" />
+         <variable name="rootComInvocCpy" type="com.goldencode.ast.Aast"/>
+         <variable name="methPropCpy"     type="com.goldencode.ast.Aast"/>
+                     <!-- convert legacy node -->
+                     <rule>ref2 != null
+                        <action>name = ref2.text</action>
+                        <!-- get the method/prop alias -->
+                        <action>ocxType = ch2wtype.get(ocxHandleKey)</action>
+                        <action>ref3 = ref2.parent.nextSibling</action>
+                        <action>map = aliasMap.get(ocxType)</action>
+                        <rule>map != null
+                           <action>name1 = name.toLowerCase()</action>
+                           <action>name2 = map.get(name1)</action>
+                           <rule>name2 != null
+                             <action>name = name2</action>
+                           </rule>
+                           <rule>name2 == null
+                             <!-- check for composed properties like font:name -->
+                             <action>ref1 = copy.parent.parent.nextSibling</action>
+                             <rule>ref1 != null and ref1.type == prog.com_property
+                               <action>name2 = ref1.text.toLowerCase()</action>
+                               <action>name1 = sprintf("%s:%s", name1, name2)</action>
+                               <action>name2 = map.get(name1)</action>
+                               <rule>name2 != null
+                                  <action>ref1 = copy.parent.parent</action>
+                                  <action>ref = copy.parent.parent.parent</action>
+                                  <action>ref1.move(ref.parent, 0)</action>
+                                  <action>ref.remove()</action>
+                                  <action>name = name2</action>
+                               </rule>
+                             </rule>
+                           </rule>
+                        </rule>
+
+                        <action>widgetClass = widgetClasses.get(ocxType)</action>
+
+                        <!-- find the root com_invocation -->
+                        <action>ref = copy.parent</action>
+                        <action>rootComInvocCpy = ref</action>
+                        <while>ref.type == prog.com_invocation
+                           <action>rootComInvocCpy = ref</action>
+                           <action>ref = ref.parent</action>
+                        </while>
+
+                        <!-- find the java counterpart method -->
+                        <action>name1 = getLegacyName(widgetClass, name)</action>
+                        <rule>name1 == null and
+                              rootComInvocCpy.parent.type == prog.assign and
+                              rootComInvocCpy.indexPos == 0
+                           <!-- for prop assignment -->
+                           <action>name1 = sprintf("set%s", name)</action>
+                           <action>name1 = getLegacyName(widgetClass, name1)</action>
+                        </rule>
+
+                        <!-- for prop getter or method invocation -->
+                        <rule>name1 == null
+                           <action>name1 = sprintf("get%s", name)</action>
+                           <action>name1 = getLegacyName(widgetClass, name1)</action>
+                        </rule>
+
+                        <!-- for prop getter or method invocation -->
+                        <rule>name1 == null
+                           <action>name1 = sprintf("is%s", name)</action>
+                           <action>name1 = getLegacyName(widgetClass, name1)</action>
+                        </rule>         
+
+                        <rule>name1 == null
+                           <action>printfln("WARN: FWD OCX Extension: Failed to resolve legacy name for %s. Is %s defined in %s?", name, name, widgetClass)</action>
+                           <action>copy.putAnnotation("noop-com", true)</action>
+                        </rule>
+
+                        <rule>name1 != null
+                           <action>reftype1 = -1</action>
+                           <action>reftype = prog.lookupKeywordToken(name1)</action>
+                           <rule>reftype == -1
+                              <action>printfln("WARN: FWD OCX Extension: Failed to resolve keyword for %s.", name1)</action>
+                              <action>copy.putAnnotation("noop-com", true)</action>
+                              <action on="false">reftype1 = lookupAttributeOrMethod(reftype)</action>
+                              <rule on="false">reftype1 == -1
+                                 <action>printfln("WARN: FWD OCX Extension: Failed to resolve attribute or method type for %s.", name1)</action>
+                                 <action>copy.putAnnotation("noop-com", true)</action>
+                              </rule>
+                           </rule>
+
+                           <rule>reftype1 != -1
+                              <!-- is this an indexed COM property being assigned? -->
+                              <action>methPropCpy = rootComInvocCpy.getImmediateChild(createSet(prog.com_method, prog.com_property), null)</action>
+                              <rule>rootComInvocCpy.parent.type == prog.assign and
+                                    rootComInvocCpy.indexPos == 0 and
+                                    methPropCpy.getImmediateChild(prog.com_parameter, null) != null
+
+                                 <!-- get the assigning expression and make it a parameter -->
+                                 <action>ref1 = rootComInvocCpy.nextSibling</action>
+
+                                 <!-- the com parameter will be converted below -->
+                                 <action>ref1.type = prog.com_parameter</action>
+                                 <action>ref1.text = ""</action>
+                                 <action>ref1.move(methPropCpy, -1)</action>
+                              </rule>
+                             <rule>map != null and ref3 != null and ref3.compareWith(methPropCpy, true)
+                                 <action>printfln("hit: %s", ref3.text)</action>
+                                 <action>name3=map.get(ref3.text.toLowerCase())</action>
+                                 <action>printfln("name3= %s", name3)</action>
+                                 <action>methPropCpy.text = name3</action>
+                              </rule>
+                              <!-- set legacy node properties -->
+                              <action>ref2.type = reftype1</action>
+                              <action>ref2.text = name1</action>
+                              <action>ref2.putAnnotation("oldtype", #(long)reftype)</action>
+
+                              <!-- lookup for com parameters and replace with parameters -->
+                              <action>ref1 = ref2.firstChild</action>
+                              <while>ref1 != null
+                                 <action>ref2 = null</action>
+                                 <rule>ref1.type == prog.com_parameter
+                                    <action>ref1.type = prog.parameter</action>
+                                    <action>ref2 = ref1</action>
+                                 </rule>
+                                 <action>ref1 = ref1.nextSibling</action>
+
+                                 <!-- check for empty parameter and remove it -->
+                                 <rule>ref2 != null and ref2.numChildren == 0
+                                    <action>ref2.remove()</action>
+                                 </rule>
+                              </while>
+
+                              <!-- convert var_com_handle into var_handle -->
+                              <action>copy.type = prog.var_handle</action>
+                              <action>copy.text = ocxHandle</action>
+
+                              <!-- remove second token since is no longer needed -->
+                              <rule>cache != null
+                                 <action>cache.remove()</action>
+                              </rule>
+
+                              <!-- rearrange nodes and remove unnecessary node -->
+                              <rule>isConversion == false and copy.parent.parent != null and copy.parent.parent.type == prog.com_invocation
+                                 <action>ref1 = copy.parent</action>
+                                 <action>invoc = copy.parent.parent</action>
+                                 <action>invoc.type = prog.colon</action>
+                                 <action>copy.move(invoc, 0)</action>
+                                 <action>ref1.remove()</action>
+                              </rule>
+
+                              <!-- when is conversion  -->
+                              <rule>isConversion == true and copy.parent != null and copy.parent.type == prog.com_invocation
+                                 <action>invoc = copy.parent</action>
+                                 <action>invoc.type = prog.colon</action>
+                              </rule>
+                           </rule>
+                        </rule>
+                     </rule>
+      </function>
       <!-- Assumes that we are under browse DISPLAY node. Finds the field reference (which defines
            the column) with the given schemaname under the DISPLAY node.-->
       <function name="doTrigger">

=== modified file 'rules/convert/expressions.rules'
--- rules/convert/expressions.rules	2019-10-30 17:07:39 +0000
+++ rules/convert/expressions.rules	2020-02-25 17:15:52 +0000
@@ -4,7 +4,7 @@
 ** Module   : expressions.rules
 ** Abstract : converts Progress expression root and wrapping/unwrapping
 **
-** Copyright (c) 2005-2019, Golden Code Development Corporation.
+** Copyright (c) 2005-2020, Golden Code Development Corporation.
 **
 ** _#_ _I_ __Date__ __JPRM__ ____________________________Description_____________________________
 ** 001 GES 20050726   @21855 Good working version which converts Progress
@@ -212,6 +212,7 @@
 **                           parameters to COPY-LOB statement. Data types for such arguments must
 **                           be verified at runtime.
 ** 085 CA  20190927          Added support for direct Java access from 4GL code.
+** 086 SBI 20200225          Added Calendar widget support.
 */
 -->
 

